program adreses;

{
 Uzdevuma "Adreses" atrisinjums.
 Noskaidro, vai ievadt ciparu virkne var bt iegta IP adresm, izdzot punktus.
 Katr grup ne vairk k m cipari. Tiei n grupas.

  Mrti Opmanis, 2001
}

const
 gar_max  = 10;    { 5 - nepietiek;  10 - pietiek }
 cip_skaits_grupa = 9;   {grups bs pa deviiem cipariem}
 norm_const : longint = 1000000000; {10^cip_skaits_grupa}
 cip_max = 200;
 m_max : longint = 200;
 n_max : longint = 200;

 type
  mas = array [1..gar_max] of longint;
  skaitlis = record
              garums : byte;
              saturs : mas;
             end;


var a : array [1..cip_max,0..1] of skaitlis;
    var_sakties : array[1..cip_max] of boolean;
    f : text;
    s : string;
    i,j,k,ls,m,n1,n,augsa,kmin : longint;
    vecais, jaunais : byte;
    boo : boolean;

    ii : byte;
    parnese : longint;


 procedure Izveido_saturu(var s1:skaitlis);
  begin
   for ii:=1 to gar_max do s1.saturs[ii] := 0;
   s1.garums := 1;
  end;


 procedure Normalize(var s1:skaitlis);
  begin
   with s1 do
    begin
     saturs[garums+1] := 0;

     for ii:=1 to garums do
      begin
       parnese := saturs[ii] div norm_const;
       saturs[ii] := saturs[ii] mod norm_const;
       Inc(saturs[ii+1],parnese) ;
      end;
     if parnese>0 then Inc(garums);
    end;
  end;

 procedure Palielini(var s1:skaitlis; s2:skaitlis);

  begin

  WITH s1 DO
   BEGIN

   if garums<s2.garums
    then
     begin
      for ii:=garums+1 to s2.garums do saturs[ii] := 0;
      garums := s2.garums;
     end;

   parnese := 0;
   for ii:=1 to s2.garums do
    begin
     Inc(parnese,saturs[ii]);
     Inc(parnese,s2.saturs[ii]);
     saturs[ii] := parnese mod norm_const;
     parnese := parnese div norm_const;
    end;

   for ii:=s2.garums+1 to garums do
    if parnese=0
     then Exit
     else
      begin
       Inc(parnese,saturs[ii]);
       saturs[ii] := parnese mod norm_const;
       parnese := parnese div norm_const;
      end;

    if parnese>0
     then
      begin
       Inc(garums);
       if garums>gar_max then begin writeln(' GARUMS !!!!!!!!! '); Exit; end;
       saturs[garums] := parnese;
      end;


   END;

  end;

 procedure Pieskir(var s1:skaitlis; cik:longint);
  begin
   s1.saturs[1] := cik;
   s1.garums := 1;
   Normalize(s1);
  end;

 function Skaitlis_String(s1 : skaitlis) : string;
 var
  s_viss, s_darba : string;

  begin
   with s1 do
    begin
     Str(saturs[garums],s_viss);
     for ii:=garums-1 downto 1 do
      begin
       Str(saturs[ii],s_darba);
       if Length(s_darba)<cip_skaits_grupa
        then s_darba := Copy('000000000000',1,cip_skaits_grupa-Length(s_darba)) + s_darba;
       s_viss := s_viss + s_darba;
      end;
    end;
   Skaitlis_String := s_viss;
  end;





begin

for i:=1 to cip_max do
 for j:=0 to 1 do Izveido_saturu(a[i,j]);

FillChar(var_sakties,SizeOf(var_sakties),false);

assign(f,'adreses.dat');
reset(f);
readln(f,n,m);
readln(f,s);
Close(f);

n1 := n-1;

assign(f,'adreses.rez');
rewrite(f);

ls := Length(s);
{writeln(ls);readln;}

if ls>n*m
 then writeln(f,0)
 else
  begin
   for i:=1 to ls do var_sakties[ls+1-i] := s[i]<>'0';

   vecais := 0;
   for i:=1 to m do Pieskir(a[i,vecais],byte(var_sakties[i]));

   for j:=1 to n1 do
    begin

     jaunais := 1 - vecais;
     for i:=1 to cip_max do Pieskir(a[i,jaunais],0);

     augsa := m*(j+1);
     if augsa>ls then augsa := ls;

     for i:=j to augsa do
      if var_sakties[i]
       then
        begin
         if i>m then kmin := i - m
                else kmin := 1;
         for k:=kmin to i-1 do Palielini(a[i,jaunais],a[k,vecais]);
        end;

     vecais := jaunais;
    end;

  end;

writeln(f,Skaitlis_String(a[ls,vecais]));

close(f);

end.