program satiksme;

{
 Uzdevuma "Satiksme" atrisinjums. Zinmi atautie izbraukanas virzieni katr krustojum.
 Jnonk ldz nordtajam krustojumam un jtiek no pilstas r.

  Mrti Opmanis, 2001
}


const
 nm_max = 2500;

 taisni = 1;
 pa_labi = 2;
 pa_kreisi = 4;
 apkart = 8;
 visur = 15;

type
 viena_virz_mas = array [0..1] of longint;
 pviena_virz_mas = ^viena_virz_mas;

 pkiegelis = ^kiegelis;
 kiegelis = record
             krustojums : integer;
             virz : byte;
             nak : pkiegelis;
            end;

var
 i, j, n, m, nm, x, y, im1m, musu_krusts : integer;
 pilseta : array [0..3] of pviena_virz_mas;
 krusti : array [0..nm_max] of byte; {Iekodti atautie virzieni}
 f : Text;
 c1,c2,c3,c4,cha : char;
 lab, lab_k : array[0..3] of longint;
 maz, i_b : byte;
 pirmais, pedejais : pkiegelis;

procedure Saliec(ind : integer; c1,c2,c3,c4 : char);
var k : byte;
 begin
  k := 0;
  if c1='1' then k := taisni;
  if c2='1' then Inc(k,pa_labi);
  if c3='1' then Inc(k,pa_kreisi);
  if c4='1' then Inc(k,apkart);
  krusti[ind] := k;
 end;

{===========================================================================}
procedure Ieliec_saraksta(krusts : integer; virziens : byte);
var pp : pkiegelis;
 begin

  New(pp);
  with pp^ do
   begin
    krustojums := krusts;
    virz := virziens;
    nak := nil;
   end;

  if pedejais<>nil
   then  pedejais^.nak := pp
   else  pirmais := pp;

  pedejais := pp;

 end;

{===========================================================================}
procedure Izmet_pirmo;
var pp : pkiegelis;
 begin
 if pirmais<>nil
  then
   begin
    if pirmais = pedejais then pedejais := nil;
    pp := pirmais;
    pirmais := pirmais^.nak;
    Dispose(pp);
   end;
 end;

{===========================================================================}

procedure Pamegini(virsotne:integer; virziens_surp, virziens_prom:byte);

{Jatrod nko virsotne no s un jprbauda, vai tur nevaram tikt trk}

var virs_talak : integer;
    izmaksa : longint;
    virziens_nakosaja : byte;

 begin

  case virziens_prom of
   0 : if virsotne mod m = 0
        then
         begin
          virs_talak := 0;
          izmaksa := pilseta[virziens_surp]^[virsotne];
         end
        else
         begin
          virs_talak := virsotne + 1;
          izmaksa := pilseta[virziens_surp]^[virsotne] + 73;
         end;
   1 : if virsotne > (n-1)*m
        then
         begin
          virs_talak := 0;
          izmaksa := pilseta[virziens_surp]^[virsotne];
         end
        else
         begin
          virs_talak := virsotne + m;
          izmaksa := pilseta[virziens_surp]^[virsotne] + 59;
         end;
   2 : if virsotne mod m = 1
        then
         begin
          virs_talak := 0;
          izmaksa := pilseta[virziens_surp]^[virsotne];
         end
        else
         begin
          virs_talak := virsotne - 1;
          izmaksa := pilseta[virziens_surp]^[virsotne] + 73;
         end;
   3 : if virsotne<=m
        then
         begin
          virs_talak := 0;
          izmaksa := pilseta[virziens_surp]^[virsotne];
         end
        else
         begin
          virs_talak := virsotne - m;
          izmaksa := pilseta[virziens_surp]^[virsotne] + 59;
         end;
  end; {case}

  {Aprina, no kuras puses iebrauks jaunaj pilst}
   virziens_nakosaja := (virziens_prom + 2) mod 4;

  if izmaksa<pilseta[virziens_nakosaja]^[virs_talak]
   then
    begin
     pilseta[virziens_nakosaja]^[virs_talak] := izmaksa;
     Ieliec_saraksta(virs_talak,virziens_nakosaja);
    end;

 end;

{===========================================================================}

procedure Aizpildi_kur_var_tikt(virsotne:integer; virziens:byte);

 begin
  if virsotne>0
   then
    begin
     if krusti[virsotne] and taisni    > 0 then Pamegini(virsotne, virziens, (virziens+2) mod 4 );
     if krusti[virsotne] and pa_labi   > 0 then Pamegini(virsotne, virziens, (virziens+3) mod 4 );
     if krusti[virsotne] and pa_kreisi > 0 then Pamegini(virsotne, virziens, (virziens+1) mod 4 );
     if krusti[virsotne] and apkart    > 0 then Pamegini(virsotne, virziens, virziens );
    end;

 end;

{===========================================================================}

procedure Izpeti_no(virsotne:integer; virziens:byte);
var i : integer;
    i_byte : byte;
 begin
  for i_byte := 0 to 3 do
   for i := 0 to nm do
    pilseta[i_byte]^[i] := 99999999;

  if virsotne<>0
   then
    begin
     pilseta[virziens]^[virsotne] := 0; {Esam eit no s puses atbraukui}
     Aizpildi_kur_var_tikt(virsotne,virziens);
    end
   else
    begin
     {0 (rpuse) nav svargs virziens - esam bijui visur}
     for i_byte := 0 to 3 do pilseta[i_byte]^[0] := 0;

     for i:=1 to n do
      begin
       pilseta[0]^[i*m] := 0;         {Pilstas lab mala}
       Aizpildi_kur_var_tikt(i*m,0);
      end;
     for i:=1 to m do
      begin
       pilseta[1]^[(n-1)*m+i] := 0;   {Pilstas apaka}
       Aizpildi_kur_var_tikt((n-1)*m+i,1);
      end;
     for i:=1 to n do
      begin
       pilseta[2]^[(i-1)*m+1] := 0;   {Pilstas kreis mala}
       Aizpildi_kur_var_tikt((i-1)*m+1,2);
      end;
     for i:=1 to m do
      begin
       pilseta[3]^[i] := 0;           {Pilstas auga}
       Aizpildi_kur_var_tikt(i,3);
      end;


    end;


  while pirmais<>nil do
   begin
    with pirmais^ do
     begin
      Aizpildi_kur_var_tikt(krustojums,virz);
     end;
    Izmet_pirmo;
   end;

 end;

{===========================================================================}

begin

 krusti[0] := visur;

 Assign(f,'satiksme.dat');
 Reset(f);
 Readln(f,n,m,x,y); {Dimensijas un vajadzgais krustojums}

 nm := n*m;
 for i:=0 to 3 do GetMem(pilseta[i],(nm+1)*sizeof(longint));

 for i:=1 to n do
  begin
   im1m := (i-1)*m;
   for j:=1 to m-1 do
    begin
     Read(f,c1,c2,c3,c4,cha);
     Saliec(im1m+j,c1,c2,c3,c4);
    end;
   Readln(f,c1,c2,c3,c4);
   Saliec(im1m+m,c1,c2,c3,c4);
  end;
 Close(f);

 pirmais := nil;
 pedejais := nil;

 Assign(f,'SATIKSME.REZ');
 Rewrite(f);

 musu_krusts := (x-1)*m + y;

 Izpeti_no(0,0);    {Krustojums un virziens}
 for i:=0 to 3 do lab[i] := pilseta[i]^[musu_krusts];

 Izpeti_no(musu_krusts,0);
 for i:=0 to 3 do lab_k[i] := lab[0] + pilseta[i]^[0];
 Izpeti_no(musu_krusts,1);
 for i:=0 to 3 do if lab_k[i] > lab[1] + pilseta[i]^[0]
                   then lab_k[i] := lab[1] + pilseta[i]^[0];
 Izpeti_no(musu_krusts,2);
 for i:=0 to 3 do if lab_k[i] > lab[2] + pilseta[i]^[0]
                   then lab_k[i] := lab[2] + pilseta[i]^[0];
 Izpeti_no(musu_krusts,3);
 for i:=0 to 3 do if lab_k[i] > lab[3] + pilseta[i]^[0]
                   then lab_k[i] := lab[3] + pilseta[i]^[0];

 {Tagad iek lab_k ir trkais, k atnkt no 0 ldz 0 caur musu_krusts}

 {Atrodam mazko}
 maz := 0;
 for i:=1 to 3 do if lab_k[maz]>lab_k[i] then maz := i;

 if lab_k[maz]<99999999
  then writeln(f,lab_k[maz])
  else writeln(f,'NEVAR');

 Close(f);

end.